<?php

/**
 * License
 *
 * @author    MagneticOne
 *
 * @copyright MagneticOne
 *
 * @license   MagneticOne
*/

include_once(dirname(__FILE__) . '/passwordhash.php');
foreach (glob(dirname(__FILE__) . '/cartsauth/*.php') as $filename) {
  include_once($filename);
}

class Auth
{
  private static $_validators;

  /**
   * @return Cart2cart_Login_Auth[]
   */
  public static function getValidators()
  {
    if (self::$_validators === null) {
      $iterator = new DirectoryIterator(__DIR__ . '/cartsauth');
      foreach ($iterator as $fileInfo) {
        if ($fileInfo->isDot() || $fileInfo->getExtension() != 'php' || $fileInfo->getBasename('.php') == 'index') {
          continue;
        }

        $className = ucfirst($fileInfo->getBasename('.php'));
        self::$_validators[$className] = new $className;
      }
    }

    return self::$_validators;
  }

  public function customValidateHash($hash, $password, $salt)
  {
    try {
      foreach (self::getValidators() as $validator) {
        if (!method_exists($validator, 'validatePassword')) {
          continue;
        }

        if (call_user_func(array($validator, 'validatePassword'), $hash, $password, (string)$salt)) {
          return true;
        }
      }

      return false;
    } catch (Exception $e) {
      return false;
    } catch (Throwable $e) {
      return false;
    }
  }
}